## 2020-03-16
### 4.3.3

__maven__

```groovy
//maven 库
repositories {
    maven{
        url "https://oss.sonatype.org/content/groups/public"
    }
}

//module 依赖
dependencies {
    // 地图库
    implementation 'com.tencent.map:tencent-map-vector-sdk:4.3.3.1'

    // 地图兼容库
    implementation 'com.tencent.map:sdk-compat-v4:4.3.3.1'
}
```

__新增：__
1. 支持开发者设置自定义的 userid:
    接口 | 说明
    -- | --
    TencentMapOptions.setCustomUserID(String cuid) | 开发者可设置此 id，方便线上问题跟进
2. 支持交通事件展示功能

__优化：__
1. 比例尺单位使用中文

## 2020-01-20
### 4.3.2

__maven__

```groovy
//maven 库
repositories {
    maven{
        url "https://oss.sonatype.org/content/groups/public"
    }
}

//module 依赖
dependencies {
    // 地图库
    implementation 'com.tencent.map:tencent-map-vector-sdk:4.3.2'

    // 地图兼容库
    implementation 'com.tencent.map:sdk-compat-v4:4.3.2'
}
```

__优化：__

1. 优化地图配置，减少地图显示异常情况；

__修改：__

1. 解决 TileOverlay 移除时小概率出现空指针的问题；
2. 废弃 Marker.setInMapCenterState，不再维护接口功能，后续版本不再保证该接口可用性。

__新增：__
1. 个性化图层能力开放，使用前需要用户在地图[官网上传数据](https://lbs.qq.com/dev/console/customLayer/create)，审核通过后方可使用。

## 2019-12-17
### 4.3.1

__maven__

```groovy
//maven 库
repositories {
    maven{
        url "https://oss.sonatype.org/content/groups/public"
    }
}

//module 依赖
dependencies {
    // 地图库
    implementation 'com.tencent.map:tencent-map-vector-sdk:4.3.1'

    // 地图兼容库
    implementation 'com.tencent.map:sdk-compat-v4:4.3.1'
}
```

__优化：__

1. 暗色模式效果优化，海外图支持暗色模式，比例尺、指南针等地图内置控件支持暗色模式；

__修改：__

1. 废弃接口：
    - TencentMap.isBlockRouteEnabled
    - TencentMap.setBlockRouteEnabled
    - UiSettings.setZoomPosition
    - UiSettings.setZoomControlsEnabled
    - UiSettings.isZoomControlsEnabled


## 2019-11-25
### 4.3.0

__maven__

```groovy
//maven 库
repositories {
    maven{
        url "https://oss.sonatype.org/content/groups/public"
    }
}

//module 依赖
dependencies {
    // 地图库
    implementation 'com.tencent.map:tencent-map-vector-sdk:4.3.0'

    // 地图兼容库
    implementation 'com.tencent.map:sdk-compat-v4:4.3.0'

    // 地图工具包
    implementation 'com.tencent.map:sdk-utilities:1.0.5'
}
```

__优化：__

1. 优化旋转手势易触发问题

__修改：__

1. 解决无障碍模式下的 crash 问题
2. 解决 infowindow 未保存室内状态问题
3. 解决 ViewInfowindow 刷新时的空指针问题
4. 解决 LineText 在 armv7a 架构上无法移除问题

__新增：__

1.暗色模式

    - 统一底图类型入口 TencentMap.setMapType(int mapType)，底图类型目前共三种：TencentMap.MAP_TYPE_NORMAL、TencentMap.MAP_TYPE_DARK、TencentMap.MAP_TYPE_SATELLITE;
    - 废弃 TencentMap.setSatelliteEnabled(boolean enable)，请使用 TencentMap.setMapType(TencentMap.MAP_TYPE_SATELLITE);
    - 废弃 TencentMap.isSateLiteEnable(), 请使用 TencentMap.getMapType();

## 2019-11-11
### 4.2.9

__maven__

```groovy
//maven 库
repositories {
    maven{
        url "https://oss.sonatype.org/content/groups/public"
    }
}

//module 依赖
dependencies {
    // 地图库
    implementation 'com.tencent.map:tencent-map-vector-sdk:4.2.9'

    // 地图兼容库
    implementation 'com.tencent.map:sdk-compat-v4:4.2.9'

    // 地图工具包
    implementation 'com.tencent.map:sdk-utilities:1.0.5'
}
```

__修改：__

1. 解决已知问题，提高稳定性；

__新增：__

1. 发布地图工具包，支持点聚合和 marker 平移动画；

## 2019-10-15
### 4.2.8

__maven__

```groovy
//maven 库
repositories {
    maven{
        url "https://oss.sonatype.org/content/groups/public"
    }
}

//module 依赖
dependencies {
    // 地图库
    implementation 'com.tencent.map:tencent-map-vector-sdk:4.2.8'

    // 地图兼容库
    implementation 'com.tencent.map:sdk-compat-v4:4.2.8'
}
```

__修改：__

1. 解决 Android Q 可能白屏的问题；
2. 解决已知问题，提高稳定性；

__优化：__

1. 优化 InfoWindowAdapter 处理逻辑；

## 2019-09-04
### 4.2.7
__maven__

```groovy
//maven 库
repositories {
    maven{
        url "https://oss.sonatype.org/content/groups/public"
    }
}

//module 依赖
dependencies {
    // 地图库
    implementation 'com.tencent.map:tencent-map-vector-sdk:4.2.7'

    // 地图兼容库
    implementation 'com.tencent.map:sdk-compat-v4:4.2.7'
}
```

__新增：__

1. 支持沿 polyline 展示的文字功能

    接口 | 说明
    -- | --
    PolylineOptions.text(Text text) | 沿创建的 polyline 展示文字，满足导航场景下动态路名需求。<br/>注：只要调用 TencentMap.addPolyline(PolylineOptions) 构造出 Polyline 实例就不可以再调用 Polyline.setPoints(List) 修改 Text 展示的路径，只能创建新的 Polyline

    Text 支持的属性：

    接口 | 说明
    -- | --
    Builder.color(int color) | 颜色
    Builder.strokeColor(int color) | 描边颜色
    Builder.size(int size) | 文字大小
    Builder.priority(TextPriority priority) | 文字间优先级关系

2. 支持 ipv6

__修改：__

1. 解决单指双击缩放地图时级别变化不连贯问题;
2. 解决 ViewInfowindow 不能移除问题。从这个版本开始，用户在使用 InfoWindowAdapter 返回自定义的 view 时，应保证每个 marker 返回自己的 infowindow view;
3. 修复 onCameraChangeFinish 回调可能返回多次问题；

__优化：__

1. Polyline 置灰接口效率优化，避免出现闪烁现象；
2. 优化 sdk 包体积。其中资源文件 20k；精简 so 库 200 k，代码段精简 11%；

## 2019-08-14
### 4.2.6.2
__maven__

```groovy
//maven 库
repositories {
    maven{
        url "https://oss.sonatype.org/content/groups/public"
    }
}

//module 依赖
dependencies {
    // 地图库
    implementation 'com.tencent.map:tencent-map-vector-sdk:4.2.6.2'
    
    // 地图兼容库
    implementation 'com.tencent.map:sdk-compat-v4:4.2.6.2'
}
```
__新增：__

1. 限制地图区域

    接口 | 说明
    -- | --
    TencentMap.setRestrictBounds(LatLngBounds restrictBounds, RestrictBoundsFitMode fitMode) | 此接口同时会限制地图的最小缩放级别，用户还可以通过 {@link TencentMap#setMinZoomLevel(int)} 修改自己需要的最小缩放级别获取需要的展示效果

    RestrictBoundsFitMode 为用户提供了两种限制屏幕中区域的方式：

    枚举 | 说明
    -- | --
    FIT_WIDTH | 此模式会以 bounds 宽度为参考值限制地图的控制区域，在最小限制级别时 bounds 的纵向区域可能显示不完整, 可调用 TencentMap.setMinZoomLevel(int) 修改最小限制级别以展示完整的区域
    FIT_HEIGHT |  此模式会以 bounds 高度为参考值限制地图的控制区域，在最小限制级别时 bounds 的横向区域可能显示不完整, 可调用 TencentMap.setMinZoomLevel(int) 修改最小限制级别以展示完整的区域

__修改：__

1. Android Q 兼容性优化
2. 当用户通过 CameraUpdateFactory.newLatLngBounds 获取到的 CameraUpdate 为参数调用 TencentMap.moveCamera 或 TencentMap.animateCamera 接口修改地图视野时，不再修改地图的旋转角度和倒伏角度。
3. 修复与导航 sdk 兼容性问题
4. 解决已知问题，提高稳定性

__优化：__

1. 精简 sdk 体积，降低 9%

## 2019-07-22
### 4.2.5
__maven__

```groovy
//maven 库
repositories {
    maven{
        url "https://oss.sonatype.org/content/groups/public"
    }
}

//module 依赖
dependencies {
    implementation 'com.tencent.map:tencent-map-vector-sdk:4.2.5'
}
```

__新增：__

1. 支持 ViewInfoWindow，marker 的 infowindow 可以直接以 view 实现

接口名称 | 接口说明
-- | --
MarkerOptions.viewInfoWindow(boolean enabled) | 设置此 marker 的 infowindow 是否用 view 实现 infowindow

2. 添加检索功能<br>
地图数据检索能力封装了 lbs.qq.com 提供的 webservice 接口, 上线使用时应先[申请配额](https://lbs.qq.com/console/myquota.html?console=myquota)，避免因配额问题导致的 app 异常。目前地图 sdk 提供的检索功能包括

    - 地点检索
    - 关键词补全
    - 逆地址解析（坐标位置描述）
    - 地址解析（地址转坐标）
    - 行政区划
    - 坐标转换
    - 街景场景信息查询
    - 路线规划

__修改：__

1. 热力图接口标准化，与 4.2.4 及以前版本不兼容。如果用户希望使用旧版热力图接口可引入腾讯地图兼容库 tencent-mapsdk-compat-v4，用户可使用压缩包中提供的 jar 包或者使用 maven 引入项目

    ```groovy
    //module 依赖
    dependencies {
        implementation 'com.tencent.map:sdk-compat-v4:4.2.5'
    }
    ```

    用户需要使用 tencent-mapsdk-compat-v4 库中提供的 compat 类才能调用 comapt 库中提供的各种兼容方法，主要类的对应关系如下：

    原始类 | 兼容类
    -- | --
    MapFragment | MapFragmentCompat
    MapRenderLayer | MapRenderLayerCompat
    MapView | MapViewCompat
    SupportMapFragment | SupportMapFragmentCompat
    TencentMap | TencentMapCompat
    TextureMapView | TextureMapViewCompat

__优化：__

1. 3d室内图展现效果优化，欢迎企业用户合作、接入。

## 2019-06-17
### 4.2.4
__maven__

```groovy
//maven 库
repositories {
    maven{
        url "https://oss.sonatype.org/content/groups/public"
    }
}

//module 依赖
dependencies {
    implementation 'com.tencent.map:tencent-map-vector-sdk:4.2.4'
}
```

__新增：__

1. 支持自定义字体：

    接口名称 | 接口说明
    -- | --
    TencentMapOptions.setTypeface(Typeface typeface) | 地图内部字体统一使用 {@link Typeface#DEFAULT}，默认修改仅影响地图内字体
    TencentMapOptions.setTypeface(Typeface typeface, boolean global) | 地图内部字体统一使用 {@link Typeface#DEFAULT}，true-全局DEFAULT字体将变化 false-仅地图内部字体变化

2. TileOverlay 接口:

    TencentMap 提供添加 TileOverlay 的接口方法

    接口名称 | 接口说明
    -- | --
    TencentMap.addTileOverlay(TileOverlayOptions options)) | 添加瓦片图层

    其中 TileOverlayOptions 参数必须设置 TileProvider 接口的实现类用于向地图指定位置添加栅格图片，用户需要实现
    TileProvider 中的方法

    ```java
    TileProvider

    /**
    * 返回指定x, y, zoom值对应的栅格瓦片
    *
    * @param x
    *         瓦片数据的 x 坐标，取值范围 [0, 2^z -1]
    * @param y
    *         瓦片数据的 y 坐标，取值范围 [0, 2^z -1]
    * @param zoom
    *         瓦片数据的级别, 取值范围 [{@link TencentMap#getMinZoomLevel()}, {@link TencentMap#getMaxZoomLevel()}]
    * @return
    */
    public Tile getTile(int x, int y, int zoom);
    ```

    UrlTileProvider 是地图提供的一个 TileProvider 抽象类，用户需要实现 getTileUrl 方法，地图 sdk 接管瓦片数据的下载

    ```java
    UrlTileProvider

    /**
    * 根据瓦片参数，返回对应的服务器地址。服务器返回的必须是对应瓦片的图片数据流。
    *
    * @param x
    * @param y
    * @param zoom
    * @return
    */
    public abstract URL getTileUrl(int x, int y, int zoom);
    ```

    TileOverlayOptions 提供的其他方法：

    接口名称 | 接口说明
    -- | --
    TileOverlayOptions.tileProvider(TileProvider tileProvider) | 设置瓦片源
    TileOverlayOptions.diskCacheDir(String diskCacheDir) | 设置磁盘缓存路径
    TileOverlayOptions.versionInfo(String versionInfo) | 设置瓦片图层数据的版本信息
    TileOverlayOptions.zIndex(int zindex) | 设置瓦片的绘制层级，该参数只对添加多层 TileOverlay 的情况下有意义
    TileOverlayOptions.betterQuality(boolean betterQuality) | 当前 TileOverlay 是否以高清模式加载

__修改：__

1. 线宽默认为 9dp
2. 适配 Android Q
3. 修改指南针开关行为，不再与地图状态关联；指南针样式修改；</br>
    影响接口：

    接口名称 | 接口说明
    -- | --
    TencentMap.setCompassEnabled(boolean flag) | 设置是否显示指南针

4. 3d 楼块展示效果开关不再与地图状态关联；</br>
    影响接口：

    接口名称 | 接口说明
    -- | --
    TencentMap.setBuildingEnable(boolean use3DStyle) | 设置是否显示3D建筑

## 2019-04-28
### 4.2.3.1
__修改：__
1. 修改 support 库版本为 28.0.0

## 2019-03-25
### 4.2.3

__新增：__
1. 步行路线规划功能 <br>
路线规划功能封装了lbs.qq.com 提供的 webservice 接口, 上线使用时应先[申请配额](https://lbs.qq.com/console/myquota.html?console=myquota)，避免因配额问题导致的 app 异常。<br>
步行方案规划使用WalkingParam设置步行检索参数，查询输入参数为起点，终点，代码如下所示。

    ```java
    LatLng start = new LatLng(39.984154,116.307490);
    LatLng destination = new LatLng(39.882342,116.433106);
    TencentSearch tencentSearch = new TencentSearch(this);
    WalkingParam walkingParam = new WalkingParam();
    walkingParam.from(start);
    walkingParam.to(destination);
    ```

    调用TencentSearch.getRoutePlan(RoutePlanningParam param, HttpResponseListener listener)方法，在HttpResponseListener.onSuccess(int statusCode, T object)回调中获取查询结果：

    ```java
    tencentSearch.getRoutePlan(walkingParam, new HttpResponseListener<WalkingResultObject>() {
        @Override
        public void onSuccess(int statusCode, WalkingResultObject object) {
            if (object == null) {
                return;
            }
            Log.e("searchdemo", "plan success");
            //TODO 解析 WalkingResultObject
        }

        @Override
        public void onFailure(int statusCode, String responseString, Throwable throwable) {
            Toast.makeText(RoadPlanActivity.this, responseString, Toast.LENGTH_SHORT).show();
        }
    });
    ```

    返回结果中的routes字段是一个List,表明结果可能有多条路线，其元素类型为WalkingResultObject.Route，包含了这条路线的方向、距离、所需时间、路线点串（用于在地图画出路线），以及分段的路线计划steps。<br>
    steps也是一个List,其元素类型为RoutePlanningObject.Step，该类提供了用于导航的信息，这些信息的分析如下：<br>

    - RoutePlanningObject.Step.accessorial_desc 本段的附加信息,可能为空，如“进入北四环西路”
    - RoutePlanningObject.Step.act_desc 本段的动作，如“右转”
    - RoutePlanningObject.Step.dir_desc 本段的方向，如“北”
    - RoutePlanningObject.Step.distance 本段的长度，单位：米
    - RoutePlanningObject.Step.duration 本段的用时，单位：分钟
    - RoutePlanningObject.Step.instruction 腾讯提供的本段的默认信息，如“向北步行100m,右转进入北四环西路”
    - RoutePlanningObject.Step.polyline_idx 本段的起点和终点在点串中的位置
    - RoutePlanningObject.Step.road_name 本段的路名，如“彩和坊路”

__修改：__
1. 修复已知问题，提高稳定性
